New Protocols Must Require TLS 1.3
Internet-Draft draft-ietf-uta-require-tls13-02
Rich Salz
Akamai Technologies
rsalz@akamai.com
Nimrod Aviram
nimrod.aviram@gmail.com
30 August 2024
Security
Using TLS in Applications
TLS
features
TLS 1.2 is in widespread use and can be configured such that it provides good security properties. TLS 1.3 is also in widespread use and fixes some known deficiencies with TLS 1.2, such as removing error-prone cryptographic primitives and encrypting more of the traffic so that it is not readable by outsiders.
Since TLS 1.3 use is widespread, new protocols must require and assume its existence. This prescription does not pertain to DTLS (in any DTLS version); it pertains to TLS only.
This document updates [RFC9325].
About This Document
Status information for this document may be found at https://datatracker.ietf.org/doc/draft-ietf-uta-require-tls13/.
Discussion of this document takes place on the Using TLS in Applications Working Group mailing list (mailto:uta@ietf.org), which is archived at https://mailarchive.ietf.org/arch/browse/uta/. Subscribe at https://www.ietf.org/mailman/listinfo/uta/.
Source for this draft and an issue tracker can be found at https://github.com/richsalz/draft-use-tls13.
Introduction
TLS 1.2 [TLS12] is in widespread use and can be configured such that it provides good security properties. However, this protocol version suffers from several deficiencies:
1. While application layer traffic is always encrypted, most of the handshake messages are not. Therefore, the privacy provided is suboptimal. This is a protocol issue that cannot be addressed by configuration.
2. The list of cryptographic primitives specified for the protocol, both in-use primitives and deprecated ones, includes several primitives that have been a source for vulnerabilities throughout the years, such as RSA key exchange, CBC cipher suites, and problematic finite-field Diffie-Hellman group negotiation. These issues could be addressed through proper configuration; however, experience shows that configuration mistakes are common, especially when deploying cryptography. See Section 6 for elaboration.
3. The base protocol does not provide security against some types of attacks (see Section 6); extensions are required to provide security.
TLS 1.3 [TLS13] is also in widespread use and fixes most known deficiencies with TLS 1.2, such as encrypting more of the traffic so that it is not readable by outsiders and removing most cryptographic primitives considered dangerous. Importantly, TLS 1.3 enjoys robust security proofs and provides excellent security without any additional configuration.
This document specifies that, since TLS 1.3 use is widespread, new protocols must require and assume its existence. This prescription does not pertain to DTLS (in any DTLS version); it pertains to TLS only.
Conventions and Definitions
The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", "SHOULD", "SHOULD NOT", "RECOMMENDED", "NOT RECOMMENDED", "MAY", and "OPTIONAL" in this document are to be interpreted as described in BCP 14 [RFC2119] [RFC8174] when, and only when, they appear in all capitals, as shown here.
Implications for post-quantum cryptography
Cryptographically-relevant quantum computers, once available, will have a huge impact on TLS. In 2016, the US National Institute of Standards and Technology (NIST) started a multi-year effort to standardize algorithms that will be "safe" once quantum computers are feasible [PQC]. First IETF discussions happened around the same time [CFRGSLIDES].
While the industry is waiting for NIST to finish standardization, the IETF has several efforts underway. A working group was formed in early 2023 to work on use operational and transitional uses of PQC in IETF protocols, [PQUIPWG]. Several other working groups, notably LAMPS [LAMPSWG] and TLS [TLSWG], are working on drafts to support hybrid algorithms and identifiers, for use during a transition from classic to a post-quantum world.
For TLS it is important to note that the focus of these efforts is TLS 1.3 or later: TLS 1.2 WILL NOT be supported (see Section 7). This is one more reason for new protocols to default to TLS 1.3, where post-quantum cryptography is expected to be supported.
TLS Use by Other Protocols and Applications
Any new protocol that uses TLS MUST specify as its default TLS 1.3. For example, QUIC [QUICTLS] requires TLS 1.3 and specifies that endpoints MUST terminate the connection if an older version is used.
If deployment considerations are a concern, the protocol MAY specify TLS 1.2 as an additional, non-default option. As a counter example, the Usage Profile for DNS over TLS [DNSTLS] specifies TLS 1.2 as the default, while also allowing TLS 1.3. For newer specifications that choose to support TLS 1.2, those preferences are to be reversed.
The initial TLS handshake allows a client to specify which versions of the TLS protocol it supports and the server is intended to pick the highest version that it also supports. This is known as the "TLS version negotiation," and many TLS libraries provide a way for applications to specify the range of versions. When the API allows it, clients SHOULD specify just the minimum version they want. This SHOULD be TLS 1.3 or TLS 1.2, depending on the circumstances described in the above paragraphs.
Changes to RFC 9325
This document makes two changes to the recommendations in [RFC9325], Section 3.1.1:
- That section says that TLS 1.3 SHOULD be supported; this document says that for new protocols it MUST be supported.
- That section says that TLS 1.2 MUST be supported; this document says that it MAY be supported as described above.
Again, these changes only apply to TLS, and not DTLS.
Security Considerations
TLS 1.2 was specified with several cryptographic primitives and design choices that have, over time, weakened its security. The purpose of this section is to briefly survey several such prominent problems that have affected the protocol. It should be noted, however, that TLS 1.2 can be configured securely; it is merely much more difficult to configure it securely as opposed to using its modern successor, TLS 1.3. See [RFC9325] for a more thorough guide on the secure deployment of TLS 1.2.
Firstly, the TLS 1.2 protocol, without any extension points, is vulnerable to renegotiation attacks (see [RENEG1] and [RENEG2]) and the Triple Handshake attack (see [TRIPLESHAKE]). Broadly, these attacks exploit the protocol's support for renegotiation in order to inject a prefix chosen by the attacker into the plaintext stream. This is usually a devastating threat in practice, that allows e.g. obtaining secret cookies in a web setting. In light of the above problems, [RFC5746] specifies an extension that prevents this category of attacks. To securely deploy TLS 1.2, either renegotiation must be disabled entirely, or this extension must be used. Additionally, clients must not allow servers to renegotiate the certificate during a connection.
Secondly, the original key exchange methods specified for the protocol, namely RSA key exchange and finite field Diffie-Hellman, suffer from several weaknesses. Similarly, to securely deploy the protocol, these key exchange methods must be disabled. See [I-D.draft-ietf-tls-deprecate-obsolete-kex] for details.
Thirdly, symmetric ciphers which were widely-used in the protocol, namely RC4 and CBC cipher suites, suffer from several weaknesses. RC4 suffers from exploitable biases in its key stream; see [RFC7465]. CBC cipher suites have been a source of vulnerabilities throughout the years. A straightforward implementation of these cipher suites inherently suffers from the Lucky13 timing attack [LUCKY13]. The first attempt to implement the cipher suites in constant time introduced an even more severe vulnerability [LUCKY13FIX]. There have been further similar vulnerabilities throughout the years exploiting CBC cipher suites; refer to e.g. [CBCSCANNING] for an example and a survey of similar works.
And lastly, historically the protocol was affected by several other attacks that TLS 1.3 is immune to: BEAST [BEAST], Logjam [WEAKDH], FREAK [FREAK], and SLOTH [SLOTH].
IANA Considerations
This document makes no requests to IANA.
References
Normative References
[TLS12]

The Transport Layer Security (TLS) Protocol Version 1.2
T. Dierks
E. Rescorla
August 2008
RFC 5246
DOI 10.17487/RFC5246
[TLS13]

The Transport Layer Security (TLS) Protocol Version 1.3
E. Rescorla
August 2018
RFC 8446
DOI 10.17487/RFC8446
[RFC2119]

Key words for use in RFCs to Indicate Requirement Levels
S. Bradner
March 1997
BCP 14
RFC 2119
DOI 10.17487/RFC2119
[RFC8174]

Ambiguity of Uppercase vs Lowercase in RFC 2119 Key Words
B. Leiba
May 2017
BCP 14
RFC 8174
DOI 10.17487/RFC8174
[RFC9325]

Recommendations for Secure Use of Transport Layer Security (TLS) and Datagram Transport Layer Security (DTLS)
Y. Sheffer
P. Saint-Andre
T. Fossati
November 2022
BCP 195
RFC 9325
DOI 10.17487/RFC9325
[RFC5746]

Transport Layer Security (TLS) Renegotiation Indication Extension
E. Rescorla
M. Ray
S. Dispensa
N. Oskov
February 2010
RFC 5746
DOI 10.17487/RFC5746
[I-D.draft-ietf-tls-deprecate-obsolete-kex]

Deprecating Obsolete Key Exchange Methods in TLS 1.2
Carrick Bartle
Roblox
Nimrod Aviram
26 June 2024
Internet-Draft draft-ietf-tls-deprecate-obsolete-kex-04
[RFC7465]

Prohibiting RC4 Cipher Suites
A. Popov
February 2015
RFC 7465
DOI 10.17487/RFC7465
Informative References
[QUICTLS]

Using TLS to Secure QUIC
M. Thomson, Ed.
S. Turner, Ed.
May 2021
RFC 9001
DOI 10.17487/RFC9001
[DNSTLS]

Usage Profiles for DNS over TLS and DNS over DTLS
S. Dickinson
D. Gillmor
T. Reddy
March 2018
RFC 8310
DOI 10.17487/RFC8310
[PQC]

Post=Quantum Cryptography
January 2017
[CFRGSLIDES]

Post Quantum Secure Cryptography Discussion
David McGrew
n.d.
[PQUIPWG]

Post-Quantum Use in Protocols
n.d.
[LAMPSWG]

Limited Additional Mechanisms for PXIK and SMIME
n.d.
[TLSWG]

Transport Layer Security
n.d.
[TRIPLESHAKE]

Triple Handshakes Considered Harmful Breaking and Fixing Authentication over TLS
n.d.
[RENEG1]

Understanding the TLS Renegotiation Attack
Eric Rescorla
n.d.
[RENEG2]

Authentication Gap in TLS Renegotiation
Marsh Ray
n.d.
[LUCKY13]

Lucky Thirteen: Breaking the TLS and DTLS record protocols
N. J. Al Fardan
K. G. Paterson
n.d.
[LUCKY13FIX]

Systematic fuzzing and testing of TLS libraries
Juraj Somorovsky
n.d.
[CBCSCANNING]

Scalable Scanning and Automatic Classification of TLS Padding Oracle Vulnerabilities
Robert Merget
Juraj Somorovsky
Nimrod Aviram
Craig Young
Janis Fliegenschmidt
JÃ¶rg Schwenk
Yuval Shavitt
n.d.
[BEAST]

Here come the xor ninjas
Thai Duong
Juliano Rizzo
n.d.
[WEAKDH]

Imperfect forward secrecy: How Diffie-Hellman fails in practice
D. Adrian
K. Bhargavan
Z. Durumeric
P. Gaudry
M. Green
J. A. Halderman
N. Heninger
D. Springall
E. ThomÃ©
L. Valenta
B. VanderSloot
n.d.
[FREAK]

A messy state of the union: Taming the composite state machines of TLS
Benjamin Beurdouche
Karthikeyan Bhargavan
Antoine Delignat-Lavaud
CÃ©dric Fournet
Markulf Kohlweiss
Alfredo Pironti
Pierre-Yves Strub
Jean Karim Zinzindohoue
n.d.
[SLOTH]

Transcript collision attacks: Breaking authentication in TLS, IKE, and SSH
Karthikeyan Bhargavan
GaÃ«tan Leurent
n.d.